self.importScripts('process_client-20250419.js','process_common-20250419.js');


// listen for main to transfer the buffer to myWorker
self.onmessage = function handleMessageFromMain(msg) {
	
	var cmpArrayBuffer = msg.data.cmpAB;
	var cmpLength = msg.data.cmpL;
	var decompLength = msg.data.rawL;
	var study = msg.data.study;

//	console.log('buffer received in worker ', cmpArrayBuffer.byteLength );

	var _t0 = performance.now();
	
	var cmpHeapBytes = new WasmMem();
	cmpHeapBytes.set( new Uint8Array( msg.data.cmpAB ) );

	msg.data.cmpAB = null;

	var rawHeapBytes = new WasmMem();
	rawHeapBytes.allocate( decompLength );
	
	var _t1 = performance.now();
	
	let result = Module._gwav4_decompress(cmpHeapBytes.byteOffset, cmpHeapBytes.length, rawHeapBytes.byteOffset, rawHeapBytes.length);
	
	var _t2 = performance.now();
	
	cmpHeapBytes.release();
	
	var rawArrayBuffer = new ArrayBuffer(decompLength);
	var decompArray = new Uint8Array(rawArrayBuffer);
	decompArray.set(rawHeapBytes.array()); 

	rawHeapBytes.release();

	var _t3 = performance.now();

	console.log('DECOMP ', msg.data.lbl, '(', cmpLength, ') => (', decompLength, ')  in: ' , _t1-_t0, ',', _t2-_t1, ',', _t3-_t2);

	var rmsg = new Object();
	//rmsg.cmpAB = cmpArrayBuffer;
	//rmsg.cmpL = cmpLength;
	rmsg.rawAB = rawArrayBuffer;
	rmsg.study = study;

	// send buf back to main and transfer the underlying ArrayBuffer
	//self.postMessage(rmsg, [rmsg.cmpAB,rmsg.rawAB]);
	self.postMessage(rmsg, [rmsg.rawAB]);
};
