
class WasmMem {
	constructor() {
		this.length = 0;
		this.byteOffset = 0;
	}
	set(typedArray) {
		this.length = typedArray.length * typedArray.BYTES_PER_ELEMENT;
		this.byteOffset = Module._malloc(this.length);
		var heapBytes = Module.HEAPU8.subarray(this.byteOffset, this.byteOffset + this.length);
		heapBytes.set(typedArray);
	}
	allocate(size) {
		this.byteOffset = Module._malloc(size);
		this.length = size;
	}
	release() {
		if( this.byteOffset > 0 ) { 
			Module._free(this.byteOffset);
		}
	}
	array() {
		return Module.HEAPU8.subarray(this.byteOffset, this.byteOffset + this.length);
	}
};

